#!/usr/bin/perl

use strict;
use warnings;

use DBI;
use DBD::mysql;

use Test::More tests => 2;
#use Test::Exception;

use lib '..';
use Warden;

# Fake $ENV values
BEGIN {
  $ENV{'SSL_CLIENT_S_DN_CN'} = '?';
  $ENV{'SSL_CLIENT_CERT'}    = '?';
  $ENV{'REMOTE_ADDR'}        = '?';
  $ENV{'SERVER_NAME'}        = 'warden-dev.cesnet.cz';
  $ENV{'SERVER_ADDR'}        = '195.113.161.39';
  $ENV{'SERVER_PORT'}        = '443';
}


my $ret;


our $MAX_EVENTS_LIMIT = "1000000";
our %VALID_STRINGS = (
"type" => ["portscan", "bruteforce", "probe", "spam", "phishing", "botnet_c_c", "dos", "malware", "copyright", "webattack", "test", "other"],
);

our $DBH = DBI->connect("DBI:mysql:database=warden;host=localhost", "root", "w4rd3n&r00t", {RaiseError => 1, mysql_auto_reconnect => 1}) || die "Could not connect to database: $DBI::errstr";

#print $ENV{'SSL_CLIENT_S_DN_CN'};
#foreach (keys %ENV){
#  print "$_ -> $ENV{$_}\n";
#}

#trim test
$ret = Warden::trim('   a  ');
is($ret,'a','Trim si OK.');


# Alternate names test
#$alt_names, $ip, $service_type, $client_type, $function_name
#$ret = Warden::getAltNames("warden-dev.cesnet.cz","195.113.161.39","honeyscan","s","someEvent");
#is($ret, '', 'Alternate names are OK.');

# Client authorizaton test
#$ret = Warden::authorizeClient("warden-dev.cesnet.cz","195.113.161.39","honeyscan","s","someEvent");
#is($ret, undef, 'Client is unregistered.');

#$ret = Warden::authorizeClient();
#is($ret, undef, 'Client is from the unauthorized subnet.');

#$ret = Warden::authorizeClient();
#is($ret, undef, 'Everything is fine.');

# Save event test
#$class, $data
#dies_ok {Warden::saveNewEvent()} 'Cannot do insert statement.';

#my @event_ok = ("honeyscan", "1234567890", "portscan","IP", "123.123.123.123", "TCP", "22", "1234567890", "important note or comment", "null", "20");
#$ret = Warden::saveNewEvent("a",@event_ok);
#ok($ret, 'Everything is fine.');

# Get new event
#dies_ok {Warden::getNewEvents()} 'Cannot work with the database.';

#$ret = Warden::getNewEvents();
#is($ret, @EVENTS, 'Everything is fine.');

# Get last ID test
#dies_ok {Warden::getLastId()} 'Cannot prepare statment.';

$ret = Warden::getLastId();
print $ret. "\n";
is($ret, '16302246', 'GetLastID is OK.');
